Skip to main content
POST
/
v1
/
table
/
{id}
/
version
/
create
Create a new table version
curl --request POST \
  --url {scheme}://{host}:{port}/{basePath}/v1/table/{id}/version/create \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --data '
{
  "version": 1,
  "manifest_path": "<string>",
  "identity": {
    "api_key": "<string>",
    "auth_token": "<string>"
  },
  "context": {},
  "id": [
    "<string>"
  ],
  "branch": "<string>",
  "manifest_size": 1,
  "e_tag": "<string>",
  "metadata": {},
  "naming_scheme": "V2"
}
'
import requests

url = "{scheme}://{host}:{port}/{basePath}/v1/table/{id}/version/create"

payload = {
    "version": 1,
    "manifest_path": "<string>",
    "identity": {
        "api_key": "<string>",
        "auth_token": "<string>"
    },
    "context": {},
    "id": ["<string>"],
    "branch": "<string>",
    "manifest_size": 1,
    "e_tag": "<string>",
    "metadata": {},
    "naming_scheme": "V2"
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.text)
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: JSON.stringify({
    version: 1,
    manifest_path: '<string>',
    identity: {api_key: '<string>', auth_token: '<string>'},
    context: {},
    id: ['<string>'],
    branch: '<string>',
    manifest_size: 1,
    e_tag: '<string>',
    metadata: {},
    naming_scheme: 'V2'
  })
};

fetch('{scheme}://{host}:{port}/{basePath}/v1/table/{id}/version/create', options)
  .then(res => res.json())
  .then(res => console.log(res))
  .catch(err => console.error(err));


{
  "context": {},
  "transaction_id": "<string>",
  "version": {
    "version": 1,
    "manifest_path": "<string>",
    "manifest_size": 1,
    "e_tag": "<string>",
    "timestamp_millis": 123,
    "metadata": {}
  }
}
{
  "type": "/errors/bad-request",
  "title": "Malformed request",
  "status": 400,
  "detail": "",
  "instance": "/v1/namespaces"
}
{
  "type": "/errors/unauthorized-request",
  "title": "No valid authentication credentials for the operation",
  "status": 401,
  "detail": "",
  "instance": "/v1/namespaces"
}
{
  "type": "/errors/forbidden-request",
  "title": "Not authorized to make this request",
  "status": 403,
  "detail": "",
  "instance": "/v1/namespaces"
}
{
  "type": "/errors/not-found-error",
  "title": "Not found Error",
  "status": 404,
  "detail": "",
  "instance": "/v1/namespaces/{ns}"
}
{
  "type": "/errors/conflict",
  "title": "The namespace has been concurrently modified",
  "status": 409,
  "detail": "",
  "instance": "/v1/namespaces/{ns}"
}
{
  "type": "/errors/service-unavailable",
  "title": "Slow down",
  "status": 503,
  "detail": "",
  "instance": "/v1/namespaces"
}
{
  "type": "/errors/server-error",
  "title": "Internal Server Error",
  "status": 500,
  "detail": "",
  "instance": "/v1/namespaces"
}

Authorizations

Authorization
string
header
required

The access token received from the authorization server in the OAuth 2.0 flow.

Path Parameters

id
string
required

string identifier of an object in a namespace, following the Lance Namespace spec. When the value is equal to the delimiter, it represents the root namespace. For example, v1/namespace/$/list performs a ListNamespace on the root namespace.

Query Parameters

delimiter
string

An optional delimiter of the string identifier, following the Lance Namespace spec. When not specified, the $ delimiter must be used.

Body

application/json

Request to create a new table version entry. This supports put_if_not_exists semantics, where the operation fails if the version already exists.

version
integer<int64>
required

Version number to create

Required range: x >= 0
manifest_path
string
required

Path to the manifest file for this version

identity
object

Identity information of a request.

context
object

Arbitrary context as key-value pairs. How to use the context is custom to the specific implementation.

On a request, it carries caller-provided context to the implementation. On a response, it carries implementation-provided context back to the caller.

REST NAMESPACE ONLY Context entries are mapped to and from HTTP headers using the header. prefix:

  • On a request, any entry whose key starts with header. is sent as an HTTP request header with the prefix stripped. For example, the entry {"header.Authorization": "Bearer abc"} is sent as the request header Authorization: Bearer abc.
  • On a response, every HTTP response header is returned as an entry whose key is the header name prefixed with header.. For example, the response header x-request-id: abc123 is returned as the entry {"header.x-request-id": "abc123"}.
id
string[]

The table identifier

branch
string

Branch to target. When not specified, the main branch is used.

manifest_size
integer<int64>

Size of the manifest file in bytes

Required range: x >= 0
e_tag
string

Optional ETag for the manifest file

metadata
object

Optional metadata for the version

naming_scheme
string

The naming scheme used for manifest files in the _versions/ directory.

Known values:

  • V1: _versions/{version}.manifest - Simple version-based naming
  • V2: _versions/{inverted_version}.manifest - Zero-padded, reversed version number (uses u64::MAX - version) for O(1) lookup of latest version on object stores

V2 is preferred for new tables as it enables efficient latest-version discovery without needing to list all versions.

Example:

"V2"

Response

Result of creating a table version

Response for creating a table version

context
object

Arbitrary context as key-value pairs. How to use the context is custom to the specific implementation.

On a request, it carries caller-provided context to the implementation. On a response, it carries implementation-provided context back to the caller.

REST NAMESPACE ONLY Context entries are mapped to and from HTTP headers using the header. prefix:

  • On a request, any entry whose key starts with header. is sent as an HTTP request header with the prefix stripped. For example, the entry {"header.Authorization": "Bearer abc"} is sent as the request header Authorization: Bearer abc.
  • On a response, every HTTP response header is returned as an entry whose key is the header name prefixed with header.. For example, the response header x-request-id: abc123 is returned as the entry {"header.x-request-id": "abc123"}.
transaction_id
string

Optional transaction identifier

version
object